# $Id: observablewebquery.py 3231 2010-03-09 16:45:20Z wsl $
# $URL: https://svn.non-gnu.uvt.nl/uvt-dev/tags/sources/meresco/bzv-8.6.2/src/observablewebquery.py $

import re
from merescocore.framework import Observable
from merescocomponents.web import WebQuery

def addAndExactArguments(query, arguments):
	if not query.isEmpty():
		query.AND()

	for fieldAndTerm in arguments:
		field, term = fieldAndTerm.split(':', 1)
		query.addFilter(field, term)
		query.EXACT()

	for i in range(1, len(arguments)):
		query.AND()

def webQueryParseTree(httpQuery, drilldownArguments, extra):
	cql = WebQuery(httpQuery, antiUnaryClause='meresco.exists exact true').ast

	if drilldownArguments:
		addAndExactArguments(cql, drilldownArguments)

	if extra:
		addAndExactArguments(cql, extra)

	return cql

emptyQueryMatcher = re.compile('^\s*$')

class ObservableWebQuery(Observable):
	def parseQuery(self, httpQuery, drilldownArguments, extra=[]):
		if emptyQueryMatcher.match(httpQuery):
			return None, None
		ast = webQueryParseTree(httpQuery, drilldownArguments, extra)
		print ast.prettyPrint()
		print ast.toCQL()
		return ast, str(ast)
